CREATE TABLE GRID_1DD_RISK 
(	G1D_ID NUMBER(10,0), 
CTY_ID VARCHAR2(2 BYTE), 
DROUGHT_RISK NUMBER, 
DROUGHT_RISK_PRODUCT NUMBER, 
EXP_VULN_MATRIX NUMBER, 
EXP_VULN_CLASS NUMBER 
);

COMMENT ON COLUMN GRID_1DD_RISK.DROUGHT_RISK IS 'Current values of LDI v.2 correspond to the values of e20180407 _SUNSHINE[hours] suffix in column name means that only grid 1dd cells with more than [hours] hours of sunshine are considered in computation.';
COMMENT ON COLUMN GRID_1DD_RISK.EXP_VULN_MATRIX IS 'Values of exposure/vulnerability matrix (Propensity to Damage) calculated by get_expvuln.sql (v.1), with logic defined into the code. These should not be considered anymore for risk (LDI) computation (assign_risk.sql).';
COMMENT ON COLUMN GRID_1DD_RISK.EXP_VULN_CLASS IS 'Values of exposure/vulnerability matrix (Propensity to Damage) calculated by get_expvuln_v2.sql, with logic defined in tables EXPOSURE_CLASSES, VULNERABILITY_CLASSES, EXP_VULN_MATRIX (, HAZARD_CLASSES). Those are the operational values to be considered for risk (LDI) computation (assign_risk_v2.sql).';

CREATE INDEX GRID_1DD_RISK_INDEX_G1D ON GRID_1DD_RISK (G1D_ID);
ALTER TABLE GRID_1DD_RISK MODIFY (G1D_ID NOT NULL ENABLE);
