FUNCTION SUNSHINE_HOURS
( DAY_NR IN NUMBER
, LAT IN NUMBER
) RETURN NUMBER AS 
  pi              number := 3.141592653;
  p               number;
  i               number;
  a               number;
  sunshinehours   number;
BEGIN
  p := ASIN(.39795*COS(.2163108 + 2*ATAN(.9671396*TAN(.0086*(DAY_NR-186)))));
  i := (SIN(0.8333*pi/180) + SIN(LAT*pi/180)*SIN(p)) / (COS(LAT*pi/180)*COS(p));
  a := ABS(i);
  IF a > 1 THEN
    i := a/i;
  END IF;
  sunshinehours := ROUND(24-((24/pi)*ACOS(i)),1);
  RETURN sunshinehours;
END SUNSHINE_HOURS;

FUNCTION GET_HAZARD 
  -- Input:
( SPI01 IN NUMBER 
, SPI03 IN NUMBER 
, SPI12 IN NUMBER 
, SPI01_PREV IN NUMBER 
, SPI03_PREV IN NUMBER 
, FAPAR_ANOM IN NUMBER 
, SM_ANOM IN NUMBER 
, PREV_HAZARD IN NUMBER 
) RETURN NUMBER AS 
  hazard number;
  --recovering BOOLEAN := FALSE;
BEGIN
  hazard := 0;
  
  IF (SPI03 < -1) THEN
    hazard := 2;
  ELSIF (SPI12 < -1 AND SPI03 < -1) THEN
    hazard := 3;
  ELSIF (SPI03_PREV < -1) THEN
    hazard := 14;
  END IF;
  
  IF (SPI01 < -2) THEN
    hazard := 1;
  ELSIF (SPI01_PREV < -2) THEN
    hazard := 13;
  END IF;
  
  IF (SM_ANOM < -1) THEN                                              -- 1.3
    IF (SPI03 < -1) THEN
      hazard := 5;
    ELSIF ((spi03 < -1) AND (SPI12 < -1)) THEN
      hazard := 6;
    ELSIF (SPI01 < -2) THEN
      hazard := 4;
    /* removed in the algorithm
    IF (PREV_HAZARD = 1) THEN
      hazard := 4;
    ELSIF (PREV_HAZARD = 2) THEN
      hazard := 5;
    ELSIF (PREV_HAZARD = 3) THEN
      hazard := 6;
    */
    END IF;
  END IF;
  
  IF (FAPAR_ANOM < -1) THEN
    IF ((spi03 < -1) AND (spi12 < -1) AND (SM_ANOM < -1)) THEN        -- 1.3
      hazard := 10;
    ELSIF ((SPI03 < -1) AND (SM_ANOM < -1)) THEN                      -- 1.3
      hazard := 9;
    ELSIF (SPI03 < -1) THEN
      hazard := 8;
    ELSIF (SPI01 < -2) THEN
      hazard := 7;
    ELSIF (SPI03_PREV < -1) THEN
      hazard := 12;
    ELSIF (SPI01_PREV < -2) THEN
      hazard := 11;
    END IF;
  END IF;
  
  RETURN hazard;
END GET_HAZARD;

FUNCTION get_risk_v2
( expvuln_class IN number
, cdi IN number
)
  RETURN number
AS
  risk_val number;
  cursor get_risk is
    SELECT RISK_VAL,HAZARD_CLASS,EXPVULN_CLASS FROM RISK_MATRIX;
  my_risk get_risk%rowtype;
BEGIN
 OPEN get_risk;
 LOOP
  FETCH get_risk into my_risk;
  EXIT WHEN get_risk%NOTFOUND;
  IF(my_risk.EXPVULN_CLASS=risk_val2class(expvuln_class,'expvuln') AND my_risk.HAZARD_CLASS=risk_val2class(cdi,'hazard')) THEN
    risk_val :=  my_risk.RISK_VAL;
  END IF;
 END LOOP;
 CLOSE get_risk;
RETURN risk_val;
END;